/*
* Copyright 2015, 2019 Wave Informatica S.r.l..
*
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at
*
*      http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
*/
package com.waveinformatica.ocean.core.controllers.events;

import java.io.OutputStream;
import java.util.logging.Level;
import java.util.logging.Logger;

import org.apache.commons.lang.Validate;
import org.xhtmlrenderer.pdf.ITextRenderer;

import com.itextpdf.text.Document;
import com.itextpdf.text.DocumentException;
import com.itextpdf.text.pdf.PdfCopy;
import com.itextpdf.text.pdf.PdfReader;
import com.itextpdf.text.pdf.PdfStamper;
import com.itextpdf.text.pdf.PdfWriter;
import com.itextpdf.text.pdf.interfaces.PdfViewerPreferences;
import com.waveinformatica.ocean.core.controllers.results.WebPageResult;
import com.waveinformatica.ocean.core.util.LoggerUtils;

/**
 * @author Ivano Culmine
 * @author Marco Merli
 */
public class PdfPostRendererEvent extends Event {
	
	private final PdfReader reader;
	private final OutputStream output;
	private final WebPageResult result;
	
	private PdfWriter writer;
	private PdfStamper stamper;
	private PdfCopy copier;
	private ITextRenderer renderer;
	@Deprecated
	private PdfViewerPreferences handler;
	
	public PdfPostRendererEvent(Object source, String operation,
		  PdfReader reader, OutputStream output, WebPageResult result, ITextRenderer renderer) {
		
		super(source, CoreEventName.PDF_RENDERER_POST_LAYOUT.name(), new String[] {
			operation, "*"
		});
		
		this.reader = reader;
		this.output = output;
		this.result = result;
		this.renderer = renderer;
	}
	
	
	public ITextRenderer getRenderer() {
		return renderer;
	}


	public void setRenderer(ITextRenderer renderer) {
		this.renderer = renderer;
	}


	/**
	 * Setups a PdfWriter for rebuilding the PDF. Call it just once and before calling
	 * {@link PdfPostRendererEvent#getHandler() getHandler}. Since 2.1.0 this API has
	 * been deprecated because rewritten to be more strictly typed.
	 * 
	 * @param document the document for the writer
	 * @deprecated
	 * @since 2.0
	 */
	@Deprecated
	public void setupWriterHandler(Document document)
	{
		try {
			writer = PdfWriter.getInstance(document, output);
			handler = writer;
		}
		catch (DocumentException e) {
			Logger.getLogger(PdfPostRendererEvent.class.getName()).log(Level.SEVERE, null, e);
		}
	}
	
	/**
	 * Setups a PdfStamper for rebuilding the PDF. Call it just once and before calling
	 * {@link PdfPostRendererEvent#getHandler() getHandler}. Since 2.1.0 this API has
	 * been deprecated because rewritten to be more strictly typed.
	 * 
	 * @deprecated
	 * @since 2.0
	 */
	@Deprecated
	public void setupStamperHandler()
	{
		try {
			stamper = new PdfStamper(reader, output);
			handler = stamper;
		}
		catch (Exception e) {
			Logger.getLogger(PdfPostRendererEvent.class.getName()).log(Level.SEVERE, null, e);
		}
	}
	
	/**
	 * Retrieves the reader to read the PDF file built by the decorator (from the template).
	 * 
	 * @return the decorator generated PDF's reader
	 * @since 2.0
	 */
	public PdfReader getReader()
	{
		return reader;
	}
	
	/**
	 * Returns the PdfWriter or the PdfStamper generated by the related setup method.
	 * Since 2.1.0 this API has been deprecated because rewritten to be more strictly typed.
	 * 
	 * @return the PdfWriter or the PdfStamper
	 * @deprecated
	 * @since 2.0
	 */
	@Deprecated
	public PdfViewerPreferences getHandler()
	{
		Validate.notNull(handler, "handler is still null - setup it.");
		
		return handler;
	}
	
	/**
	 * Returns if a PdfWriter or a PdfStamper has been built using the related
	 * setup method.
	 * Since 2.1.0 this API has been deprecated because rewritten to be more strictly typed.
	 * 
	 * @return <code>true</code> if a PdfWriter or PdfStamper exists
	 * @deprecated
	 * @since 2.0
	 */
	@Deprecated
	public boolean hasHandler()
	{
		return handler != null;
	}
	
	/**
	 * Returns and, if not already built, builds a PdfWriter for the specified document.
	 * The <code>document</code> parameter is required only the first time: for the next
	 * calls, this method will return the same instance of the PdfWriter.
	 * 
	 * @param document the document for the PdfWriter
	 * @return the built PdfWriter
	 * @throws IllegalStateException if a PdfStamper has been built before
	 * @since 2.1
	 */
	public PdfWriter getWriter(Document document) {
		if ((handler != null && !(handler instanceof PdfWriter)) || stamper != null) {
			throw new IllegalStateException("Use only PdfWriter, PdfStamper or PdfCopy in " + CoreEventName.PDF_RENDERER_POST_LAYOUT.name() + " event");
		}
		if (writer == null) {
			try {
				writer = PdfWriter.getInstance(document, output);
				handler = writer;
			}
			catch (DocumentException e) {
				LoggerUtils.getLogger(PdfPostRendererEvent.class).log(Level.SEVERE, null, e);
			}
		}
		return writer;
	}
	
	/**
	 * Returns and, if not already built, builds a PdfStamper.
	 * For the next calls, this method will return the same instance of the PdfWriter.
	 * 
	 * @return the built PdfStamper
	 * @throws IllegalStateException if a PdfWriter has been built before
	 * @since 2.1
	 */
	public PdfStamper getStamper() {
		if ((handler != null && !(handler instanceof PdfStamper)) || writer != null) {
			throw new IllegalStateException("Use only PdfWriter, PdfStamper or PdfCopy in " + CoreEventName.PDF_RENDERER_POST_LAYOUT.name() + " event");
		}
		if (stamper == null) {
			try {
				stamper = new PdfStamper(reader, output);
				handler = stamper;
			}
			catch (Exception e) {
				LoggerUtils.getLogger(PdfPostRendererEvent.class).log(Level.SEVERE, null, e);
			}
		}
		return stamper;
	}
	
	/**
	 * Returns and, if not already built, builds a PdfCopy for the specified document.
	 * The <code>document</code> parameter is required only the first time: for the next
	 * calls, this method will return the same instance of the PdfCopy.
	 * 
	 * @param document the document for the PdfCopy
	 * @return the built PdfCopy
	 * @throws IllegalStateException if a PdfCopy has been built before
	 * @since 2.1
	 */
	public PdfCopy getCopier(Document document) {
		if ((handler != null && !(handler instanceof PdfCopy)) || copier != null) {
			throw new IllegalStateException("Use only PdfWriter, PdfStamper or PdfCopy in " + CoreEventName.PDF_RENDERER_POST_LAYOUT.name() + " event");
		}
		if (copier == null) {
			try {
				copier = new PdfCopy(document, output);
				handler = copier;
			}
			catch (Exception e) {
				LoggerUtils.getLogger(PdfPostRendererEvent.class).log(Level.SEVERE, null, e);
			}
		}
		return copier;
	}
	
	/**
	 * Returns <code>true</code> if a PdfWriter has been built
	 * 
	 * @return <code>true</code> if a PdfWriter has been built
	 * @since 2.1
	 */
	public boolean hasWriter() {
		return writer != null;
	}
	
	/**
	 * Returns <code>true</code> if a PdfStamper has been built
	 * 
	 * @return <code>true</code> if a PdfStamper has been built
	 * @since 2.1
	 */
	public boolean hasStamper() {
		return stamper != null;
	}
	
	/**
	 * Returns <code>true</code> if a PdfCopy has been built
	 * 
	 * @return <code>true</code> if a PdfCopy has been built
	 * @since 2.1
	 */
	public boolean hasCopier() {
		return copier != null;
	}
	
	/**
	 * Returns <code>true</code> if no PdfStamper or PdfCopy has been built, so that a PdfWriter can be used
	 * 
	 * @return <code>true</code> if a PdfWriter cam be built
	 * @since 2.1
	 */
	public boolean canHaveWriter() {
		return stamper == null;
	}
	
	/**
	 * Returns <code>true</code> if no PdfWriter or PdfCopy has been built, so that a PdfStamper can be used
	 * 
	 * @return <code>true</code> if a PdfStamper cam be built
	 * @since 2.1
	 */
	public boolean canHaveStamper() {
		return writer == null;
	}
	
	/**
	 * Returns <code>true</code> if no PdfWriter or PdfStamper has been built, so that a PdfCopy can be used
	 * 
	 * @return <code>true</code> if a PdfCopy cam be built
	 * @since 2.1
	 */
	public boolean canHaveCopier() {
		return copier == null;
	}
	
	/**
	 * Returns the {@link WebPageResult} result for the PDF
	 * 
	 * @return the {@link WebPageResult} result for the PDF
	 * @since 2.1
	 */
	public WebPageResult getResult()
	{
		return result;
	}
	
}

